[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.2 and 1.19

version 1.2, 2021/10/05 01:39:05 version 1.19, 2021/10/21 02:02:52
Line 6 
Line 6 
         sed -n "$1" /var/run/dmesg.boot          sed -n "$1" /var/run/dmesg.boot
 }  }
   
 installed_firmware() {  # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
         for fw in ${PKGDIR}/$1-firmware*; do  
                 [ -e "$fw" ] || continue  # Create a temporary directory based on the supplied directory name prefix.
                 echo ${fw##*/}  tmpdir() {
           local _i=1 _dir
   
           until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                   ((++_i < 10000)) || return 1
         done          done
           echo "$_dir"
 }  }
   
 set -A _KERNV -- $( scan_dmesg '/^OpenBSD \([1-9][0-9]*\.[0-9]\)\([^ ]*\) .*/ { s//\1 \2/p; q; }' )  # Run a command ($2+) as unprivileged user ($1).
 VNAME=${_KERNV[0]}  # Take extra care that after "cmd" no "user" processes exist.
 OSDIR=$VNAME  #
 if ((${#_KERNV[*]} > 1)) && [ "$_KERNV[1]" = "-current" -o "$_KERNV[1]" = "-beta" ]; then  # Optionally:
         OSDIR=snapshots  #       - create "file" and chown it to "user"
 fi  #       - after "cmd", chown "file" back to root
   #
   # Usage: do_as user [-f file] cmd
   do_as() {
           (( $# >= 2 )) || return
   
 FWURL=http://firmware.openbsd.org/firmware/${OSDIR}          local _file _rc _user=$1
 PKGDIR=${DESTDIR}/var/db/pkg          shift
 PATTERNS="file:${0%/*}/firmware_patterns"  
   
 drivers=$(          if [[ $1 == -f ]]; then
         last=''                  _file=$2
         ftp -D "Detecting" -Vmo- $PATTERNS |                  shift 2
         while read d m; do          fi
                 [ "$last" = "$d" ] && continue  
                 [ "$m" ] || m="^$d[0-9][0-9]* at "          if [[ -n $_file ]]; then
                 grep -q "$m" /var/run/dmesg.boot || continue                  >$_file
                 echo $d                  chown "$_user" "$_file"
                 last=$d          fi
   
           doas -u "$_user" "$@"
           _rc=$?
   
           while doas -u "$_user" kill -9 -1 2>/dev/null; do
                   echo "Processes still running for user $_user after: $@"
                   sleep 1
         done          done
 )  
   
 if [ -z "$drivers" ]; then          [[ -n $_file ]] && chown root "$_file"
         echo "No devices found which need firmware files to be downloaded." >&2  
         exit 0  
 fi  
   
 tmpdir=${DESTDIR}/tmp/fw_update          return $_rc
 [ -e "$tmpdir" ] && rm -rf "$tmpdir"  }
 mkdir -p "$tmpdir"  
 cd "$tmpdir"  
   
 # TODO: Drop privs during fetch and verify  unpriv() {
 ftp -D Get -Vm "$FWURL/SHA256.sig"          do_as _sndio "$@"
   }
   
 # Probably should bundle the firmware sigfile on the installer,  unpriv2() {
 # although we can just get it from the recently installed system.          do_as _file "$@"
 if [ "$DESTDIR" ]; then  }
         sigfile=$( sed -n '/^untrusted comment: verify with \(.*\)$/ { s//\1/p; q; }' SHA256.sig )  
         if [ ! -e "/etc/signify/$sigfile" ] \  
           && [ -e "${DESTDIR}/etc/signify/$sigfile" ]; then  
                 cp -a "${DESTDIR}/etc/signify/$sigfile" "/etc/signify/$sigfile"  
         fi  
 fi  
   
 signify -Ve -x SHA256.sig -m - < SHA256.sig > SHA256  _issue=
   fail() {
           echo $_issue >&2
           exit 1
   }
   
 for d in $drivers; do  VNAME=$(sysctl -n kern.osrelease)
         firmware=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" SHA256 )  VERSION="${VNAME%.*}${VNAME#*.}"
         installed=$( installed_firmware $d )  FWDIR="$VNAME"
   
         for i in $installed; do  # TODO: We need the firmware for the system we just installed
                 if [ "$firmware" = "$i.tgz" ]; then  #       not the one we booted from.  For example:
                         echo "Firmware for $d already installed ($installed)"  #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release
                         continue 2  #         will install the firmware from the 7.0 directory instead of
                 fi  #         from the snapshots dir.
         done  #       If they're using sysupgrade, then the installer kernel will be correct.
   #       If we're doing this in the installer we can check what they picked
   #       for downloading sets and use that value.
   #       Otherwise, the fw_update after first boot will fix it up for us.
   
         mkdir $d  HTTP_FWDIR=$FWDIR
   set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")
   [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
   
         # TODO: Drop privs during fetch and verify  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
         ftp -D "Get/Verify" -Vmo- "$FWURL/$firmware" | sha256 -bph "$d/h" > "$firmware"  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
         fgrep -qx "SHA256 ($firmware) = $(<$d/h)" SHA256  PKGDIR=${DESTDIR}/var/db/pkg
   PATTERNS="file:${0%/*}/firmware_patterns"
   
         # TODO: Check hash for files before deleting  fw_update() {
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then          local _tmpsrc _f _r _remove _i _installed
                 echo "Uninstalling $installed"          local _src=$FWURL _t=Get _cfile="/tmp/SHA256" _srclocal=false
                 cwd=${PKGDIR}/$installed          local _d _drivers=$(
                   last=''
                   ftp -D "Detecting" -Vmo- $PATTERNS |
                   while read _d _m; do
                           grep=grep
                           [ "$last" = "$_d" ] && continue
                           [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
                           [ "$_m" = "${_m#^}" ] && grep=fgrep
                           $grep -q "$_m" /var/run/dmesg.boot || continue
                           echo $_d
                           last=$_d
                   done
           )
   
                 remove="${cwd}/+CONTENTS ${cwd}"          if [ -z "$_drivers" ]; then
                   echo "No devices found which need firmware files to be downloaded." >&2
                   return
           fi
   
                 while read c g; do          if _tmpsrc=$( tmpdir "${DESTDIR}/tmp/fw_update" ); then
                         case $c in                  (
                         @cwd) cwd=$g                  >$_tmpsrc/t &&
                           ;;                  $_unpriv cat $_tmpsrc/t
                         @*) continue                  ) >/dev/null 2>&1 ||
                           ;;                      rm -r $_tmpsrc
                         *)  remove="$cwd/$c $remove"          fi
                           ;;  
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do          [[ ! -d $_tmpsrc ]] &&
                         if [ -d "$r" ]; then                  _issue="Cannot create prefetch area" && fail
                                 # Try hard not to actually remove recursively  
                                 # without rmdir on the install media.          # Cleanup from previous runs.
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"          rm -f $_cfile $_cfile.sig
                         else  
                                 rm -f "$r"      _t=Get/Verify
   
           ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
               _issue="Cannot fetch SHA256.sig" && fail
   
           # Verify signature file with public keys.
           ! unpriv -f "$_cfile" \
               signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
               _issue="Signature check of SHA256.sig failed" && fail
   
           for _d in $_drivers; do
                   _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )
                   _installed=$(
                   for fw in "${PKGDIR}/$_d-firmware"*; do
                           [ -e "$fw" ] || continue
                           echo ${fw##*/}
                   done
           )
   
                   for _i in $_installed; do
                           if [ "$_f" = "$_i.tgz" ]; then
                                   echo "Firmware for $_d already installed ($_installed)"
                                   continue 2
                         fi                          fi
                 done                  done
         fi  
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add                  rm -f /tmp/h /tmp/fail
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall  
         echo "Installing $firmware"                  # Fetch firmware file and create a checksum by piping through
         tar -zxphf "$firmware" -C /etc "firmware/*"                  # sha256. Create a flag file in case ftp failed. Firmware
         mkdir -p ${PKGDIR}/${firmware%.tgz}/                  # from net is written to the prefetch area.
         tar -zxphf "$firmware" -C "${PKGDIR}/${firmware%.tgz}" "+*"                  ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
     ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL                  ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
                       unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
   
                   # Handle failed transfer.
                   if [[ -f /tmp/fail ]]; then
                           rm -f "$_tmpsrc/$_f"
                           _issue="Fetching of $_f failed!"
                           fail
                   fi
   
                   # Verify firmware by comparing its checksum with SHA256.
                   if fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
                           #_unver=$(rmel $_f $_unver)
                           true
                   else
                           [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
                           _issue="Checksum test for $_f failed."
                           fail
                   fi
   
                   # TODO: Check hash for files before deleting
                   if [ "$_installed" ] && [ -e "${PKGDIR}/$_installed/+CONTENTS" ]; then
                           echo "Uninstalling $_installed"
                           cwd=${PKGDIR}/$_installed
   
                           set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
   
                           while read c g; do
                                   case $c in
                                   @cwd) cwd="${DESTDIR}/$g"
                                     ;;
                                   @*) continue
                                     ;;
                                   *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"
                                     ;;
                                   esac
                           done < "${PKGDIR}/$_installed/+CONTENTS"
   
                           for _r in "${_remove[@]}" ; do
                                   if [ -d "$_r" ]; then
                                           # Try hard not to actually remove recursively
                                           # without rmdir on the install media.
                                           [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
                                   else
                                           rm -f "$_r"
                                   fi
                           done
                   fi
   
           # TODO: Add some details about the install to +CONTENTS like pkg_add
           # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall
                   echo "Installing $_f"
                   tar -zxphf "$_tmpsrc/$_f" -C "${DESTDIR}/etc" "firmware/*"
                   mkdir -p ${PKGDIR}/${_f%.tgz}/
                   tar -zxphf "$_tmpsrc/$_f" -C "${PKGDIR}/${_f%.tgz}" "+*"
                   ed -s "${PKGDIR}/${_f%.tgz}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 121 
Line 223 
 .  .
 w  w
 EOL  EOL
 done          done
   }
   
   fw_update

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.19

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>